# frozen_string_literal: true

require_relative './base'

module Ssz
  class BitList < Base
    def initialize(bits, capacity:)
      @capacity = capacity
      @bits = bits
    end

    def serialize
      bb = ByteBuffer.from_bit_array(@bits.map{|b| b ? 1 : 0})
      bb.bytes << 0 if bb.bytes.size < (@bits.size / 8) + 1 # extend buffer size
      bb.bytes[@bits.size / 8] |= 1 << (@bits.size % 8)
      bb.serialize
    end
  end
end
